<?php 

if (!defined('FORUM')) die();

require $forum_url['pan_converter_modules'].'/'.$section.'/functions.php';

$errors = array();

if (isset($_POST['convert']) )
{
	$sql_dump = $_POST['sql_dump'];
	$new_file_name = date('YmdHis').'.sqlite';
	$sql_dump_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$sql_dump;
	$sqlite_dump_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$new_file_name;
	
	$fp1 = fopen($sql_dump_path, 'r');
	$fp2 = fopen($sqlite_dump_path, 'a');
/*
	$return = array(
		'feof' => false,
		'pos'  => 0
	);
	fseek($fp1, $return['pos']);
*/
	for ($i=0; ($line = fgets($fp1)) /* && ($i < 1000)*/ ; $i++) {
		// INSERT Обработка предложения
		// phpMyAdmin if dump
		if (preg_match('/^(INSERT INTO \`[^\`]+\` )[\s\S]*VALUES$/ui', $line, $matches)) {
			$i++;
			$line = fgets($fp1);
			
			while (preg_match('/^([\s\S]+),$/u', $line, $matches2)) {
				$line = $matches[1].'VALUES'.$matches2[1].";\n";
				my_fwrite($fp2, $line);
				
				//Подготовка к // В следующем цикле
				// Если не подходит к условиям цикла, становится дополнительной строка читать.
				// По этой причине, вы должны описать этот процесс до того, как CREATE заявления
				$i++;
				$line = fgets($fp1);
			}
			if (preg_match('/;$/u', $line)) {
				$line = $matches[1].'VALUES'.$line."\n";
				my_fwrite($fp2, $line);
			}
			//Когда вы закончите INSERT заявление, процесс переходит к конверсионной работе, кроме заявления INSERT.
		}
		//В случае терминала другой стороны отвала
		elseif (preg_match('/^(INSERT INTO \`[^\`]+\` VALUES\s?)([\s\S]*\);)$/ui', $line, $matches)) {
			while (preg_match_all('/^(\((?:(?:\'(?:(?:(?!\\\\).)?(?:(?:\\\\\\\\)*\\\\)\'|[^\'])*\'|[0-9]+|NULL),? ?)+\)), ?([\s\S]*)/ui', $matches[2], $matches2)) {
				$matches[2] = $matches2[2];
				$line = $matches[1].$matches2[1].";\n";
				my_fwrite($fp2, $line);
			}
			$line = $matches[1].$matches[2]."\n";
			my_fwrite($fp2, $line);
		}
		// CREATE 
		if (preg_match('/^CREATE TABLE[\s\S]*(\`[^\`]+\`)/ui', $line, $matches)) {
			my_fwrite($fp2, "CREATE TABLE {$matches[1]} (\n");
			
			$i++;
			$line = fgets($fp1);
			
			$j = 0;
			while (!preg_match('/^\) ENGINE=/i', $line)) {
				// INT системы к целому числу, чтобы удалить AUTO_INCREMENT
				if (!preg_match('/^\s*UNIQUE KEY/ui', $line)) {
					// Мы удалили конец линии запятой в следующих заменах. Если CREATE заявление продолжается, он возрождает запятую.
					if ($j > 0) fwrite($fp2, ",\n");
					$j++;
					$line = preg_replace_callback('/^(\s*`[^`]+`\s*)(int|tinyint|samllint|mediumint|bigint)(?:\([^\)]+\))?|(AUTO_INCREMENT),?\\n$|(,\\n)$/ui', 'callback_create', $line);
					my_fwrite($fp2, $line);
				}
				$i++;
				$line = fgets($fp1);
			}
			// ") ENGINE=" В заявлении, удалить позже  ENGINE
			fwrite($fp2, "\n);\n");
			$flag_create_table = false;
		}
//		$return['pos']  = ftell($fp1);
	}
//	$return['feof'] = feof($fp1);
	fclose($fp1);
	fclose($fp2);

	$forum_flash->add_info('Dump created');
//	redirect(forum_link($forum_url['pan_converter_section'], $section), '');
}


define('FORUM_PAGE_SECTION', 'pan-converter');
define('FORUM_PAGE', 'admin-pan-converter-'.$section);
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>

	<div class="main-content main-frm">

		<div class="content-head">
			<h2 class="hn"><span>Convert MySQL to SQLite</span></h2>
		</div>

		<form class="frm-form" name="upload" action="<?php echo forum_link($forum_url['pan_converter_section'], $section) ?>" method="post">

			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_section'], $section)) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld">
						<span>Dump Files</span>
						<small>Select a MySQL or MySQLi dump file.</small>
					</label><br />
					<span class="fld-input"><select name="sql_dump">
<?php

$available_files = pan_get_all_files(FORUM_ROOT.$forum_url['pan_converter_dumps'], array('sql'));
foreach ($available_files as $sql_files) {
	echo "\t\t\t\t\t\t\t\t".'<option value="'.$sql_files.'">'.$sql_files.'</option>'."\n";
}

?>
						</select>
					</span>
				</div>
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="convert" value="Convert Now!" /></span>
			</div>
		</form>

	</div>

<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->